self.addEventListener('message', async (event) => {
    console.log(`message received: ${event.data.uri}`);
    let file = event.data.file;
    let url = event.data.uri;
    uploadFile(file, url);
});

function uploadFile(file, url) {
    let xhr = new XMLHttpRequest();
    let formData = new FormData();
    let uploadPercent;

    formData.append('file', file);

    xhr.upload.addEventListener('progress', function (e) {
        if (e.lengthComputable) {
            uploadPercent = (e.loaded / e.total) * 100;
            postMessage([true, uploadPercent.toFixed(1)]);
        }
    }, false);
    xhr.onreadystatechange = function () {
        if (xhr.readyState === XMLHttpRequest.DONE) {
            postMessage([false, "DONE"]);
        }
    }
    xhr.onerror = function () {
        // only triggers if the request couldn't be made at all
        postMessage([false, "Request failed"]);
    };

    xhr.open('POST', url, true);
    xhr.send(formData);
}